CUBIC for Fast and Long-Distance Networks
Internet-Draft draft-ietf-tcpm-rfc8312bis-10
Lisong Xu
University of Nebraska-Lincoln
Department of Computer Science and Engineering
Lincoln
NE
68588-0115
USA
xu@unl.edu
https://cse.unl.edu/~xu/
Sangtae Ha
University of Colorado at Boulder
Department of Computer Science
Boulder
CO
80309-0430
USA
sangtae.ha@colorado.edu
https://netstech.org/sangtaeha/
Injong Rhee
Bowery Farming
151 W 26TH Street, 12TH Floor
New York
NY
10001
USA
injongrhee@gmail.com
Vidhi Goel
Apple Inc.
One Apple Park Way
Cupertino
California
95014
USA
vidhi_goel@apple.com
Lars Eggert, Ed.
NetApp
Stenbergintie 12 B
Kauniainen
02700
FI
lars@eggert.org
https://eggert.org/
Transport
TCPM
CUBIC is a standard TCP congestion control algorithm that uses a cubic function instead of a linear congestion window increase function to improve scalability and stability over fast and long-distance networks. CUBIC has been adopted as the default TCP congestion control algorithm by the Linux, Windows, and Apple stacks.
This document updates the specification of CUBIC to include algorithmic improvements based on these implementations and recent academic work. Based on the extensive deployment experience with CUBIC, it also moves the specification to the Standards Track, obsoleting RFC 8312. This also requires updating RFC 5681, to allow for CUBIC's occasionally more aggressive sending behavior.
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-tcpm-rfc8312bis/.
Discussion of this document takes place on the TCPM Working Group mailing list (mailto:tcpm@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/tcpm/. Subscribe at https://www.ietf.org/mailman/listinfo/tcpm/.
Source for this draft and an issue tracker can be found at https://github.com/NTAP/rfc8312bis.
Note to the RFC Editor
xml2rfc currently renders in the XML by surrounding the corresponding text with underscores. This is highly distracting; please manually remove the underscores when doing the final edits to the text version of this document.
(There is an issue open against xml2rfc to stop doing this in the future: https://trac.tools.ietf.org/tools/xml2rfc/trac/ticket/596)
Also, please manually change "Figure" to "Equation" for all artwork with anchors beginning with "eq" - xml2rfc doesn't seem to be able to do this.
Introduction
CUBIC has been adopted as the default TCP congestion control algorithm in the Linux, Windows, and Apple stacks, and has been used and deployed globally. Extensive, decade-long deployment experience in vastly different Internet scenarios has convincingly demonstrated that CUBIC is safe for deployment on the global Internet and delivers substantial benefits over classical Reno congestion control [RFC5681]. It is therefore to be regarded as the currently most widely deployed standard for TCP congestion control. CUBIC can also be used for other transport protocols such as QUIC [RFC9000] and SCTP [RFC4960] as a default congestion controller.
The design of CUBIC was motivated by the well-documented problem classical Reno TCP has with low utilization over fast and long-distance networks [K03][RFC3649]. This problem arises from a slow increase of the congestion window following a congestion event in a network with a large bandwidth-delay product (BDP). [HLRX07] indicates that this problem is frequently observed even in the range of congestion window sizes over several hundreds of packets. This problem is equally applicable to all Reno-style standards and their variants, including TCP-Reno [RFC5681], TCP-NewReno [RFC6582][RFC6675], SCTP [RFC4960], TFRC [RFC5348], and QUIC congestion control [RFC9002], which use the same linear increase function for window growth. All Reno-style standards and their variants are collectively referred to as "Reno" in this document.
CUBIC, originally proposed in [HRX08], is a modification to the congestion control algorithm of classical Reno to remedy this problem. Specifically, CUBIC uses a cubic function instead of the linear window increase function of Reno to improve scalability and stability under fast and long-distance networks.
This document updates the specification of CUBIC to include algorithmic improvements based on the Linux, Windows, and Apple implementations and recent academic work. Based on the extensive deployment experience with CUBIC, it also moves the specification to the Standards Track, obsoleting [RFC8312]. This requires an update to Section 3 of [RFC5681], which limits the aggressiveness of Reno TCP implementations. Since CUBIC is occasionally more aggressive than the [RFC5681] algorithms, this document updates the first paragraph of Section 3 of [RFC5681], replacing it with a normative reference to guideline (1) in Section 3 of [RFC5033], which allows for CUBIC's behavior as defined in this document.
Binary Increase Congestion Control (BIC-TCP) [XHR04], a predecessor of CUBIC, was selected as the default TCP congestion control algorithm by Linux in the year 2005 and had been used for several years by the Internet community at large.
CUBIC uses a similar window increase function as BIC-TCP and is designed to be less aggressive and fairer to Reno in bandwidth usage than BIC-TCP while maintaining the strengths of BIC-TCP such as stability, window scalability, and round-trip time (RTT) fairness.
[RFC5033] documents the IETF's best current practices for specifying new congestion control algorithms, specifically, ones that differ from the general congestion control principles outlined in [RFC2914]. It describes what type of evaluation is expected by the IETF to understand the suitability of a new congestion control algorithm and the process to enable a specification to be approved for widespread deployment in the global Internet.
There are areas in which CUBIC differs from the congestion control algorithms previously published in standards-track RFCs; those changes are specified in this document. However, it is not obvious that these changes go beyond the general congestion control principles outlined in [RFC2914], so the process in [RFC5033] may not apply.
Also, the wide deployment of CUBIC on the Internet was driven by direct adoption in most of the popular operating systems, and did not follow the practices documented in [RFC5033]. However, due to the resulting Internet-scale deployment experience over a long period of time, the IETF has determined that CUBIC may be published as a standards-track specification. This decision by the IETF does not alter the general guidance in [RFC2914].
The following sections first briefly explain the design principles of CUBIC, provide the exact specification of CUBIC, and finally discuss the safety features of CUBIC following the guidelines specified in [RFC5033].
Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Design Principles of CUBIC
CUBIC is designed according to the following design principles:
Principle 1:
For better network utilization and stability, CUBIC uses both the concave and convex profiles of a cubic function to increase the congestion window size, instead of using just a convex function.
Principle 2:
To be Reno-friendly, CUBIC is designed to behave like Reno in networks with short RTTs and small bandwidth where Reno performs well.
Principle 3:
For RTT-fairness, CUBIC is designed to achieve linear bandwidth sharing among flows with different RTTs.
Principle 4:
CUBIC appropriately sets its multiplicative window decrease factor in order to balance between the scalability and convergence speed.
Principle 1 for the CUBIC Increase Function
For better network utilization and stability, CUBIC [HRX08] uses a cubic window increase function in terms of the elapsed time from the last congestion event. While most alternative congestion control algorithms to Reno increase the congestion window using convex functions, CUBIC uses both the concave and convex profiles of a cubic function for window growth.
After a window reduction in response to a congestion event detected by duplicate ACKs, Explicit Congestion Notification-Echo (ECN-Echo, ECE) ACKs [RFC3168], TCP RACK [RFC8985] or QUIC loss detection [RFC9002], CUBIC remembers the congestion window size at which it received the congestion event and performs a multiplicative decrease of the congestion window. When CUBIC enters into congestion avoidance, it starts to increase the congestion window using the concave profile of the cubic function. The cubic function is set to have its plateau at the remembered congestion window size, so that the concave window increase continues until then. After that, the cubic function turns into a convex profile and the convex window increase begins.
This style of window adjustment (concave and then convex) improves the algorithm stability while maintaining high network utilization [CEHRX09]. This is because the window size remains almost constant, forming a plateau around the remembered congestion window size of the last congestion event, where network utilization is deemed highest. Under steady state, most window size samples of CUBIC are close to that remembered congestion window size, thus promoting high network utilization and stability.
Note that congestion control algorithms that only use convex functions to increase the congestion window size have their maximum increments around the remembered congestion window size of the last congestion event, and thus introduce many packet bursts around the saturation point of the network, likely causing frequent global loss synchronizations.
Principle 2 for Reno-Friendliness
CUBIC promotes per-flow fairness to Reno. Note that Reno performs well over paths with short RTTs and small bandwidths (or small BDPs). There is only a scalability problem in networks with long RTTs and large bandwidths (or large BDPs).
A congestion control algorithm designed to be friendly to Reno on a per-flow basis must increase its congestion window less aggressively in small BDP networks than in large BDP networks.
The aggressiveness of CUBIC mainly depends on the maximum window size before a window reduction, which is smaller in small-BDP networks than in large-BDP networks. Thus, CUBIC increases its congestion window less aggressively in small-BDP networks than in large-BDP networks.
Furthermore, in cases when the cubic function of CUBIC would increase the congestion window less aggressively than Reno, CUBIC simply follows the window size of Reno to ensure that CUBIC achieves at least the same throughput as Reno in small-BDP networks. The region where CUBIC behaves like Reno is called the "Reno-friendly region".
Principle 3 for RTT Fairness
Two CUBIC flows with different RTTs have a throughput ratio that is linearly proportional to the inverse of their RTT ratio, where the throughput of a flow is approximately the size of its congestion window divided by its RTT.
Specifically, CUBIC maintains a window increase rate independent of RTTs outside the Reno-friendly region, and thus flows with different RTTs have similar congestion window sizes under steady state when they operate outside the Reno-friendly region.
This notion of a linear throughput ratio is similar to that of Reno under high statistical multiplexing where packet loss is independent of individual flow rates. However, under low statistical multiplexing, the throughput ratio of Reno flows with different RTTs is quadratically proportional to the inverse of their RTT ratio [XHR04].
CUBIC always ensures a linear throughput ratio independent of the amount of statistical multiplexing. This is an improvement over Reno. While there is no consensus on particular throughput ratios for different RTT flows, over wired Internet paths, use of a linear throughput ratio seems more reasonable than equal throughputs (i.e., the same throughput for flows with different RTTs) or a higher-order throughput ratio (e.g., a quadratical throughput ratio of Reno under low statistical multiplexing environments).
Principle 4 for the CUBIC Decrease Factor
To balance between scalability and convergence speed, CUBIC sets the multiplicative window decrease factor to 0.7, whereas Reno uses 0.5.
While this improves the scalability of CUBIC, a side effect of this decision is slower convergence, especially under low statistical multiplexing. This design choice is following the observation that HighSpeed TCP (HSTCP) [RFC3649] and other approaches (e.g., [GV02]) made: the current Internet becomes more asynchronous with less frequent loss synchronizations under high statistical multiplexing.
In such environments, even strict Multiplicative-Increase Multiplicative-Decrease (MIMD) can converge. CUBIC flows with the same RTT always converge to the same throughput independent of statistical multiplexing, thus achieving intra-algorithm fairness. In environments with sufficient statistical multiplexing, the convergence speed of CUBIC is reasonable.
CUBIC Congestion Control
This section discusses how the congestion window is updated during the different stages of the CUBIC congestion controller.
Definitions
The unit of all window sizes in this document is segments of the maximum segment size (MSS), and the unit of all times is seconds. Implementations can use bytes to express window sizes, which would require factoring in the maximum segment size wherever necessary and replacing segments_acked with the number of bytes acknowledged in Figure 4.
Constants of Interest
β_{cubic}: CUBIC multiplicative decrease factor as described in Section 4.6.
α_{cubic}: CUBIC additive increase factor used in Reno-friendly region as described in Section 4.3.
C: constant that determines the aggressiveness of CUBIC in competing with other congestion control algorithms in high BDP networks. Please see Section 5 for more explanation on how it is set. The unit for C is

segment
-------
      3
second

Variables of Interest
This section defines the variables required to implement CUBIC:
RTT: Smoothed round-trip time in seconds, calculated as described in [RFC6298].
cwnd: Current congestion window in segments.
ssthresh: Current slow start threshold in segments.
prior_cwnd: Size of cwnd in segments at the time of setting ssthresh most recently, either upon exiting the first slow start, or just before cwnd was reduced in the last congestion event.
W_{max}: Size of cwnd in segments just before cwnd was reduced in the last congestion event when fast convergence is disabled. However, if fast convergence is enabled, the size may be further reduced based on the current saturation point.
K: The time period in seconds it takes to increase the congestion window size at the beginning of the current congestion avoidance stage to W_{max}.
current_time: Current time of the system in seconds.
epoch_{start}: The time in seconds at which the current congestion avoidance stage started.
cwnd_{start}: The cwnd at the beginning of the current congestion avoidance stage, i.e., at time epoch_{start}.
W_{cubic}(t): The congestion window in segments at time t in seconds based on the cubic increase function, as described in Section 4.2.
target: Target value of congestion window in segments after the next RTT, that is, W_{cubic}(t + RTT), as described in Section 4.2.
W_{est}: An estimate for the congestion window in segments in the Reno-friendly region, that is, an estimate for the congestion window of Reno.
segments_acked: Number of MSS-sized segments acked when a "new ACK" is received, i.e., an ACK that cumulatively acknowledges the delivery of new data. This number will be a decimal value when a new ACK acknowledges an amount of data that is not MSS-sized. Specifically, it can be less than 1 when a new ACK acknowledges a segment smaller than the MSS.
Window Increase Function
CUBIC maintains the acknowledgment (ACK) clocking of Reno by increasing the congestion window only at the reception of a new ACK. It does not make any changes to the TCP Fast Recovery and Fast Retransmit algorithms [RFC6582][RFC6675].
During congestion avoidance, after a congestion event is detected by mechanisms described in Section 3.1, CUBIC uses a window increase function different from Reno.
CUBIC uses the following window increase function:

                       3
W     (t) = C * (t - K)  + W
 cubic                      max

where t is the elapsed time in seconds from the beginning of the current congestion avoidance stage, that is,

t = current_time - epoch
                        start

and where epoch_{start} is the time at which the current congestion avoidance stage starts. K is the time period that the above function takes to increase the congestion window size at the beginning of the current congestion avoidance stage to W_{max} if there are no further congestion events and is calculated using the following equation:

         ________________
        /W    - cwnd
    3  /  max       start
K = | /  ----------------
    |/           C

where cwnd_{start} is the congestion window at the beginning of the current congestion avoidance stage.
Upon receiving a new ACK during congestion avoidance, CUBIC computes the target congestion window size after the next RTT using Figure 1 as follows, where RTT is the smoothed round-trip time. The lower and upper bounds below ensure that CUBIC's congestion window increase rate is non-decreasing and is less than the increase rate of slow start [SXEZ19].

         /
         |                if W     (t + RTT) < cwnd
         |cwnd                cubic
         |
         |
         |
target = <                if W     (t + RTT) > 1.5 * cwnd
         |1.5 * cwnd          cubic
         |
         |
         |W     (t + RTT)
         | cubic          otherwise
         \

The elapsed time t in Figure 1 MUST NOT include periods during which cwnd has not been updated due to application-limited behavior (see Section 5.8).
Depending on the value of the current congestion window size cwnd, CUBIC runs in three different regions:
1. The Reno-friendly region, which ensures that CUBIC achieves at least the same throughput as Reno.
2. The concave region, if CUBIC is not in the Reno-friendly region and cwnd is less than W_{max}.
3. The convex region, if CUBIC is not in the Reno-friendly region and cwnd is greater than W_{max}.
The next sections describe the exact actions taken by CUBIC in each region.
Reno-Friendly Region
Reno performs well in certain types of networks, for example, under short RTTs and small bandwidths (or small BDPs). In these networks, CUBIC remains in the Reno-friendly region to achieve at least the same throughput as Reno.
The Reno-friendly region is designed according to the analysis in [FHP00], which studies the performance of an AIMD algorithm with an additive factor of α (segments per RTT) and a multiplicative factor of β, denoted by AIMD(α, β). p is the packet loss rate. Specifically, the average congestion window size of AIMD(α, β) can be calculated using Figure 3.

                     _______________
                    /  α * (1 + β)
AVG_AIMD(α, β) = | / ---------------
                 |/  2 * (1 - β) * p

By the same analysis, to achieve a similar average window size as Reno that uses AIMD(1, 0.5), α must be equal to,

    1 - β
3 * -----
    1 + β

Thus, CUBIC uses Figure 4 to estimate the window size W_{est} in the Reno-friendly region with

             1 - β
                  cubic
α      = 3 * ----------
 cubic       1 + β
                  cubic

which achieves approximately the same average window size as Reno in many cases. The model used to calculate α_{cubic} is not absolutely precise, but analysis and simulation [AIMD-friendliness], as well as over a decade of experience with CUBIC in the public Internet, show that this approach produces acceptable levels of rate fairness between CUBIC and Reno flows. Also, no significant drawbacks of the model have been reported. However, it would be beneficial to see continued detailed analysis on it. When receiving a new ACK in congestion avoidance (where cwnd could be greater than or less than W_{max}), CUBIC checks whether W_{cubic}(t) is less than W_{est}. If so, CUBIC is in the Reno-friendly region and cwnd SHOULD be set to W_{est} at each reception of a new ACK.
W_{est} is set equal to cwnd_{start} at the start of the congestion avoidance stage. After that, on every new ACK, W_{est} is updated using Figure 4. Note that this equation is for a connection where Appropriate Byte Counting (ABC) [RFC3465] is disabled. For a connection with ABC enabled, this equation SHOULD be adjusted by using the number of acknowledged bytes instead of acknowledged segments. Also note that this equation works for connections with enabled or disabled Delayed ACKs [RFC5681], as segments_acked will be different based on the segments actually acknowledged by a new ACK.

                       segments_acked
W    = W    + α      * --------------
 est    est    cubic        cwnd

Once W_{est} has grown to reach the cwnd at the time of most recently setting ssthresh, that is, W_{est} >= prior_cwnd, the sender SHOULD set α_{cubic} to 1 to ensure that it can achieve the same congestion window increment rate as Reno, which uses AIMD(1, 0.5).
Concave Region
When receiving a new ACK in congestion avoidance, if CUBIC is not in the Reno-friendly region and cwnd is less than W_{max}, then CUBIC is in the concave region. In this region, cwnd MUST be incremented by

target - cwnd
-------------
    cwnd

for each received new ACK, where target is calculated as described in Section 4.2.
Convex Region
When receiving a new ACK in congestion avoidance, if CUBIC is not in the Reno-friendly region and cwnd is larger than or equal to W_{max}, then CUBIC is in the convex region.
The convex region indicates that the network conditions might have changed since the last congestion event, possibly implying more available bandwidth after some flow departures. Since the Internet is highly asynchronous, some amount of perturbation is always possible without causing a major change in available bandwidth.
Unless it is overridden by the AIMD window increase, CUBIC is very careful in this region. The convex profile aims to increase the window very slowly at the beginning when cwnd is around W_{max} and then gradually increases its rate of increase. This region is also called the "maximum probing phase", since CUBIC is searching for a new W_{max}. In this region, cwnd MUST be incremented by

target - cwnd
-------------
    cwnd

for each received new ACK, where target is calculated as described in Section 4.2.
Multiplicative Decrease
When a congestion event is detected by mechanisms described in Section 3.1, CUBIC updates W_{max} and reduces cwnd and ssthresh immediately as described below. In case of packet loss, the sender MUST reduce cwnd and ssthresh immediately upon entering loss recovery, similar to [RFC5681] (and [RFC6675]). Note that other mechanisms, such as Proportional Rate Reduction [RFC6937], can be used to reduce the sending rate during loss recovery more gradually. The parameter β_{cubic} SHOULD be set to 0.7, which is different from the multiplicative decrease factor used in [RFC5681] (and [RFC6675]) during fast recovery.
In Figure 5, flight_size is the amount of outstanding data in the network, as defined in [RFC5681]. Note that a rate-limited application with idle periods or periods when unable to send at the full rate permitted by cwnd may easily encounter notable variations in the volume of data sent from one RTT to another, resulting in flight_size that is significantly less than cwnd on a congestion event. This may decrease cwnd to a much lower value than necessary. To avoid suboptimal performance with such applications, the mechanisms described in [RFC7661] can be used to mitigate this issue as it would allow using a value between cwnd and flight_size to calculate the new ssthresh in Figure 5. The congestion window growth mechanism defined in [RFC7661] is safe to use even when cwnd is greater than the receive window as it validates cwnd based on the amount of data acknowledged by the network in an RTT which implicitly accounts for the allowed receive window. Some implementations of CUBIC currently use cwnd instead of flight_size when calculating a new ssthresh using Figure 5. The implementations that use cwnd MUST use other measures to not allow cwnd to grow when bytes in flight is smaller than cwnd. That also effectively avoids cwnd from growing beyond the receive window. Such measures are important to prevent a CUBIC sender from using an arbitrarily high cwnd value in calculating the new value for ssthresh and cwnd when a congestion event is signaled, but it is not as robust as the mechanisms described in [RFC7661]. Likewise, a QUIC sender that uses cwnd to calculate a new value for the congestion window and slow-start threshold on a congestion event is required to apply similar mechanisms [RFC9002].

A side effect of setting β_{cubic} to a value bigger than 0.5 is that packet loss can happen for more than one round-trip in certain cases, but it can work efficiently in other cases, for example, when HyStart++ is used along with CUBIC or when the sending rate is limited by the application. While a more adaptive setting of β_{cubic} could help limit packet loss to a single round, it would require detailed analyses and large-scale evaluations to validate such algorithms.
Note that CUBIC MUST continue to reduce cwnd in response to congestion events due to ECN-Echo ACKs until it reaches a value of 1 MSS. If congestion events indicated by ECN-Echo ACKs persist, a sender with a cwnd of 1 MSS MUST reduce its sending rate even further. It can achieve that by using a retransmission timer with exponential backoff, as described in [RFC3168].
Fast Convergence
To improve convergence speed, CUBIC uses a heuristic. When a new flow joins the network, existing flows need to give up some of their bandwidth to allow the new flow some room for growth, if the existing flows have been using all the network bandwidth. To speed up this bandwidth release by existing flows, the following "Fast Convergence" mechanism SHOULD be implemented.
With Fast Convergence, when a congestion event occurs, W_{max} is updated as follows, before the window reduction described in Section 4.6.

       /
       |       1 + β
       |            cubic if cwnd < W    and fast convergence is enabled,
       |cwnd * ----------            max
       |            2
W    = <
 max   |                  further reduce W
       |                                  max
       |
       |                  otherwise, remember cwnd before reduction
       \cwnd

At a congestion event, if the current cwnd is less than W_{max}, this indicates that the saturation point experienced by this flow is getting reduced because of a change in available bandwidth. This flow can then release more bandwidth by reducing W_{max} further. This action effectively lengthens the time for this flow to increase its congestion window, because the reduced W_{max} forces the flow to plateau earlier. This allows more time for the new flow to catch up to its congestion window size.
Fast Convergence is designed for network environments with multiple CUBIC flows. In network environments with only a single CUBIC flow and without any other traffic, Fast Convergence SHOULD be disabled.
Timeout
In case of a timeout, CUBIC follows Reno to reduce cwnd [RFC5681], but sets ssthresh using β_{cubic} (same as in Section 4.6) in a way that is different from Reno TCP [RFC5681].
During the first congestion avoidance stage after a timeout, CUBIC increases its congestion window size using Figure 1, where t is the elapsed time since the beginning of the current congestion avoidance, K is set to 0, and W_{max} is set to the congestion window size at the beginning of the current congestion avoidance stage. In addition, for the Reno-friendly region, W_{est} SHOULD be set to the congestion window size at the beginning of the current congestion avoidance.
Spurious Congestion Events
In cases where CUBIC reduces its congestion window in response to having detected packet loss via duplicate ACKs or timeouts, there is a possibility that the missing ACK would arrive after the congestion window reduction and a corresponding packet retransmission. For example, packet reordering could trigger this behavior. A high degree of packet reordering could cause multiple congestion window reduction events, where spurious losses are incorrectly interpreted as congestion signals, thus degrading CUBIC's performance significantly.
For TCP, there are two types of spurious events - spurious timeouts and spurious fast retransmits. In case of QUIC, there are no spurious timeouts as the loss is only detected after receiving an ACK.
Spurious timeout
An implementation MAY detect spurious timeouts based on the mechanisms described in Forward RTO-Recovery [RFC5682]. Experimental alternatives include Eifel [RFC3522]. When a spurious timeout is detected, a TCP implementation MAY follow the response algorithm described in [RFC4015] to restore the congestion control state and adapt the retransmission timer to avoid further spurious timeouts.
Spurious loss detected by acknowledgements
Upon receiving an ACK, a TCP implementation MAY detect spurious losses either using TCP Timestamps or via D-SACK[RFC2883]. Experimental alternatives include Eifel detection algorithm [RFC3522] which uses TCP Timestamps and DSACK based detection [RFC3708] which uses DSACK information. A QUIC implementation can easily determine a spurious loss if a QUIC packet is acknowledged after it has been marked as lost and the original data has been retransmitted with a new QUIC packet.
This section specifies a simple response algorithm when a spurious loss is detected by acknowledgements. Implementations would need to carefully evaluate the impact of using this algorithm in different environments that may experience sudden change in available capacity (e.g., due to variable radio capacity, a routing change, or a mobility event).
When a packet loss is detected via acknowledgements, a CUBIC implementation MAY save the current value of the following variables before the congestion window is reduced.

undo_cwnd = cwnd

undo_prior_cwnd = prior_cwnd

undo_ssthresh = ssthresh

undo_W    = W
      max    max

undo_K = K

undo_epoch      = epoch
          start        start

undo_W_{est} = W
                est

Once the previously declared packet loss is confirmed to be spurious, CUBIC MAY restore the original values of the above-mentioned variables as follows if the current cwnd is lower than prior_cwnd. Restoring the original values ensures that CUBIC's performance is similar to what it would be without spurious losses.

                            \
cwnd = undo_cwnd            |
                            |
prior_cwnd = undo_prior_cwnd|
                            |
ssthresh = undo_ssthresh    |
                            |
W    = undo_W               |
 max         max            >if cwnd < prior_cwnd
                            |
K = undo_K                  |
                            |
epoch      = undo_epoch     |
     start             start|
                            |
W    = undo_W               |
 est         est            /

In rare cases, when the detection happens long after a spurious loss event and the current cwnd is already higher than prior_cwnd, CUBIC SHOULD continue to use the current and the most recent values of these variables.
Slow Start
CUBIC MUST employ a slow-start algorithm, when cwnd is no more than ssthresh. In general, CUBIC SHOULD use the HyStart++ slow start algorithm [I-D.ietf-tcpm-hystartplusplus], or MAY use the Reno TCP slow start algorithm [RFC5681] in the rare cases when HyStart++ is not suitable. Experimental alternatives include hybrid slow start [HR11], a predecessor to HyStart++ that some CUBIC implementations have used as the default for the last decade, and limited slow start [RFC3742]. Whichever start-up algorithm is used, work might be needed to ensure that the end of slow start and the first multiplicative decrease of congestion avoidance work well together.
When CUBIC uses HyStart++ [I-D.ietf-tcpm-hystartplusplus], it may exit the first slow start without incurring any packet loss and thus W_{max} is undefined. In this special case, CUBIC sets prior_cwnd = cwnd and switches to congestion avoidance. It then increases its congestion window size using Figure 1, where t is the elapsed time since the beginning of the current congestion avoidance, K is set to 0, and W_{max} is set to the congestion window size at the beginning of the current congestion avoidance stage.
Discussion
This section further discusses the safety features of CUBIC following the guidelines specified in [RFC5033].
With a deterministic loss model where the number of packets between two successive packet losses is always 1/p, CUBIC always operates with the concave window profile, which greatly simplifies the performance analysis of CUBIC. The average window size of CUBIC can be obtained by the following function:

                   ________________      ____
                  /C * (3 + β     )   4 /   3
             4   /           cubic    |/ RTT
AVG_W      = |  /  ---------------- * -------
     cubic   | /   4 * (1 - β     )       __
             |/              cubic     4 / 3
                                       |/ p

With β_{cubic} set to 0.7, the above formula reduces to:

                              ____
                 _______   4 /   3
             4  /C * 3.7   |/ RTT
AVG_W      = | / ------- * -------
     cubic   |/    1.2         __
                            4 / 3
                            |/ p

The following subsection will determine the value of C using Figure 7.
Fairness to Reno
In environments where Reno is able to make reasonable use of the available bandwidth, CUBIC does not significantly change this state.
Reno performs well in the following two types of networks:
1. networks with a small bandwidth-delay product (BDP)
2. networks with a short RTTs, but not necessarily a small BDP
CUBIC is designed to behave very similarly to Reno in the above two types of networks. The following two tables show the average window sizes of Reno TCP, HSTCP, and CUBIC TCP. The average window sizes of Reno TCP and HSTCP are from [RFC3649]. The average window size of CUBIC is calculated using Figure 7 and the CUBIC Reno-friendly region for three different values of C.
Reno TCP, HSTCP, and CUBIC with RTT = 0.1 seconds
Loss Rate P | Reno | HSTCP | CUBIC (C=0.04) | CUBIC (C=0.4) | CUBIC (C=4)
1.0e-02 | 12 | 12 | 12 | 12 | 12
1.0e-03 | 38 | 38 | 38 | 38 | 59
1.0e-04 | 120 | 263 | 120 | 187 | 333
1.0e-05 | 379 | 1795 | 593 | 1054 | 1874
1.0e-06 | 1200 | 12280 | 3332 | 5926 | 10538
1.0e-07 | 3795 | 83981 | 18740 | 33325 | 59261
1.0e-08 | 12000 | 574356 | 105383 | 187400 | 333250
Table 1 describes the response function of Reno TCP, HSTCP, and CUBIC in networks with RTT = 0.1 seconds. The average window size is in MSS-sized segments.
Reno TCP, HSTCP, and CUBIC with RTT = 0.01 seconds
Loss Rate P | Reno | HSTCP | CUBIC (C=0.04) | CUBIC (C=0.4) | CUBIC (C=4)
1.0e-02 | 12 | 12 | 12 | 12 | 12
1.0e-03 | 38 | 38 | 38 | 38 | 38
1.0e-04 | 120 | 263 | 120 | 120 | 120
1.0e-05 | 379 | 1795 | 379 | 379 | 379
1.0e-06 | 1200 | 12280 | 1200 | 1200 | 1874
1.0e-07 | 3795 | 83981 | 3795 | 5926 | 10538
1.0e-08 | 12000 | 574356 | 18740 | 33325 | 59261
Table 2 describes the response function of Reno TCP, HSTCP, and CUBIC in networks with RTT = 0.01 seconds. The average window size is in MSS-sized segments.
Both tables show that CUBIC with any of these three C values is more friendly to Reno TCP than HSTCP, especially in networks with a short RTT where Reno TCP performs reasonably well. For example, in a network with RTT = 0.01 seconds and p=10^-6, Reno TCP has an average window of 1200 packets. If the packet size is 1500 bytes, then Reno TCP can achieve an average rate of 1.44 Gbps. In this case, CUBIC with C=0.04 or C=0.4 achieves exactly the same rate as Reno TCP, whereas HSTCP is about ten times more aggressive than Reno TCP.
C determines the aggressiveness of CUBIC in competing with other congestion control algorithms for bandwidth. CUBIC is more friendly to Reno TCP, if the value of C is lower. However, it is NOT RECOMMENDED to set C to a very low value like 0.04, since CUBIC with a low C cannot efficiently use the bandwidth in fast and long-distance networks. Based on these observations and extensive deployment experience, C=0.4 seems to give a good balance between Reno-friendliness and aggressiveness of window increase. Therefore, C SHOULD be set to 0.4. With C set to 0.4, Figure 7 is reduced to:

                        ____
                     4 /   3
                     |/ RTT
AVG_W      = 1.054 * -------
     cubic               __
                      4 / 3
                      |/ p

Figure 8 is then used in the next subsection to show the scalability of CUBIC.
Using Spare Capacity
CUBIC uses a more aggressive window increase function than Reno for fast and long-distance networks.
The following table shows that to achieve the 10 Gbps rate, Reno TCP requires a packet loss rate of 2.0e-10, while CUBIC TCP requires a packet loss rate of 2.9e-8.
Required packet loss rate for Reno TCP, HSTCP, and CUBIC to achieve a certain throughput
Throughput (Mbps) | Average W | Reno P | HSTCP P | CUBIC P
1 | 8.3 | 2.0e-2 | 2.0e-2 | 2.0e-2
10 | 83.3 | 2.0e-4 | 3.9e-4 | 2.9e-4
100 | 833.3 | 2.0e-6 | 2.5e-5 | 1.4e-5
1000 | 8333.3 | 2.0e-8 | 1.5e-6 | 6.3e-7
10000 | 83333.3 | 2.0e-10 | 1.0e-7 | 2.9e-8
Table 3 describes the required packet loss rate for Reno TCP, HSTCP, and CUBIC to achieve a certain throughput, with 1500-byte packets and an RTT of 0.1 seconds.
The test results in [HLRX07] indicate that, in typical cases with a degree of background traffic, CUBIC uses the spare bandwidth left unused by existing Reno TCP flows in the same bottleneck link without taking away much bandwidth from the existing flows.
Difficult Environments
CUBIC is designed to remedy the poor performance of Reno in fast and long-distance networks.
Investigating a Range of Environments
CUBIC has been extensively studied using simulations, testbed emulations, Internet experiments, and Internet measurements, covering a wide range of network environments [HLRX07][H16][CEHRX09][HR11][BSCLU13][LBEWK16]. They have convincingly demonstrated that CUBIC delivers substantial benefits over classical Reno congestion control [RFC5681].
Same as Reno, CUBIC is a loss-based congestion control algorithm. Because CUBIC is designed to be more aggressive (due to a faster window increase function and bigger multiplicative decrease factor) than Reno in fast and long-distance networks, it can fill large drop-tail buffers more quickly than Reno and increases the risk of a standing queue [RFC8511]. In this case, proper queue sizing and management [RFC7567] could be used to mitigate the risk to some extent and reduce the packet queuing delay. Also, in large-BDP networks after a congestion event, CUBIC, due its cubic window increase function, recovers quickly to the highest link utilization point. This means that link utilization is less sensitive to an active queue management (AQM) target that is lower than the amplitude of the whole sawtooth.
Similar to Reno, the performance of CUBIC as a loss-based congestion control algorithm suffers in networks where a packet loss is not a good indication of bandwidth utilization, such as wireless or mobile networks [LIU16].
Protection against Congestion Collapse
With regard to the potential of causing congestion collapse, CUBIC behaves like Reno, since CUBIC modifies only the window adjustment algorithm of Reno. Thus, it does not modify the ACK clocking and timeout behaviors of Reno.
CUBIC also satisfies the "full backoff" requirement as described in [RFC5033]. After reducing the sending rate to one packet per RTT in response to congestion events due to ECN-Echo ACKs, CUBIC then exponentially increases the transmission timer for each packet retransmission while congestion persists.
Fairness within the Alternative Congestion Control Algorithm
CUBIC ensures convergence of competing CUBIC flows with the same RTT in the same bottleneck links to an equal throughput. When competing flows have different RTT values, their throughput ratio is linearly proportional to the inverse of their RTT ratios. This is true independently of the level of statistical multiplexing on the link. The convergence time depends on the network environments (e.g., bandwidth, RTT) and the level of statistical multiplexing, as mentioned in Section 3.4.
Performance with Misbehaving Nodes and Outside Attackers
This is not considered in the current CUBIC design.
Behavior for Application-Limited Flows
A flow is application-limited if it is currently sending less than what is allowed by the congestion window. This can happen if the flow is limited by either the sender application or the receiver application (via the receiver advertised window) and thus sends less data than what is allowed by the sender's congestion window.
CUBIC does not increase its congestion window if a flow is application-limited. Section 4.2 requires that t in Figure 1 does not include application-limited periods, such as idle periods, otherwise W_{cubic}(t) might be very high after restarting from these periods.
Responses to Sudden or Transient Events
If there is a sudden increase in capacity, e.g., due to variable radio capacity, a routing change, or a mobility event, CUBIC is designed to utilize the newly available capacity faster than Reno.
On the other hand, if there is a sudden decrease in capacity, CUBIC reduces more slowly than Reno. This remains true whether or not CUBIC is in Reno-friendly mode and whether or not fast convergence is enabled.
Incremental Deployment
CUBIC requires only changes to the congestion control at the sender, and it does not require any changes at receivers. That is, a CUBIC sender works correctly with Reno receivers. In addition, CUBIC does not require any changes to routers and does not require any assistance from routers.
Security Considerations
CUBIC makes no changes to the underlying security of TCP. More information about TCP security concerns can be found in [RFC5681].
IANA Considerations
This document does not require any IANA actions.
References
Normative References
[RFC5681]

TCP Congestion Control
M. Allman
V. Paxson
E. Blanton
September 2009
RFC 5681
DOI 10.17487/RFC5681
[RFC6582]

The NewReno Modification to TCP's Fast Recovery Algorithm
T. Henderson
S. Floyd
A. Gurtov
Y. Nishida
April 2012
RFC 6582
DOI 10.17487/RFC6582
[RFC6675]

A Conservative Loss Recovery Algorithm Based on Selective Acknowledgment (SACK) for TCP
E. Blanton
M. Allman
L. Wang
I. Jarvinen
M. Kojo
Y. Nishida
August 2012
RFC 6675
DOI 10.17487/RFC6675
[RFC5348]

TCP Friendly Rate Control (TFRC): Protocol Specification
S. Floyd
M. Handley
J. Padhye
J. Widmer
September 2008
RFC 5348
DOI 10.17487/RFC5348
[RFC9002]

QUIC Loss Detection and Congestion Control
J. Iyengar, Ed.
I. Swett, Ed.
May 2021
RFC 9002
DOI 10.17487/RFC9002
[RFC5033]

Specifying New Congestion Control Algorithms
S. Floyd
M. Allman
August 2007
BCP 133
RFC 5033
DOI 10.17487/RFC5033
[RFC2914]

Congestion Control Principles
S. Floyd
September 2000
BCP 41
RFC 2914
DOI 10.17487/RFC2914
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC3168]

The Addition of Explicit Congestion Notification (ECN) to IP
K. Ramakrishnan
S. Floyd
D. Black
September 2001
RFC 3168
DOI 10.17487/RFC3168
[RFC8985]

The RACK-TLP Loss Detection Algorithm for TCP
Y. Cheng
N. Cardwell
N. Dukkipati
P. Jha
February 2021
RFC 8985
DOI 10.17487/RFC8985
[RFC6298]

Computing TCP's Retransmission Timer
V. Paxson
M. Allman
J. Chu
M. Sargent
June 2011
RFC 6298
DOI 10.17487/RFC6298
[RFC5682]

Forward RTO-Recovery (F-RTO): An Algorithm for Detecting Spurious Retransmission Timeouts with TCP
P. Sarolahti
M. Kojo
K. Yamamoto
M. Hata
September 2009
RFC 5682
DOI 10.17487/RFC5682
[RFC4015]

The Eifel Response Algorithm for TCP
R. Ludwig
A. Gurtov
February 2005
RFC 4015
DOI 10.17487/RFC4015
[RFC2883]

An Extension to the Selective Acknowledgement (SACK) Option for TCP
S. Floyd
J. Mahdavi
M. Mathis
M. Podolsky
July 2000
RFC 2883
DOI 10.17487/RFC2883
[I-D.ietf-tcpm-hystartplusplus]

HyStart++: Modified Slow Start for TCP
Praveen Balasubramanian
Confluent
Yi Huang
Microsoft
Matt Olson
Microsoft
27 August 2022
Internet-Draft draft-ietf-tcpm-hystartplusplus-09
[RFC7567]

IETF Recommendations Regarding Active Queue Management
F. Baker, Ed.
G. Fairhurst, Ed.
July 2015
BCP 197
RFC 7567
DOI 10.17487/RFC7567
Informative References
[FHP00]

A Comparison of Equation-Based and AIMD Congestion Control
S. Floyd
M. Handley
J. Padhye
May 2000
[GV02]

Extended Analysis of Binary Adjustment Algorithms
S. Gorinsky
H. Vin
11 August 2002
Technical Report TR2002-29
Department of Computer Sciences
The University of Texas at Austin
[H16]

Simulation, Testbed, and Deployment Testing Results of CUBIC
S. Ha
03 November 2016
[AIMD-friendliness]

Friendliness between AIMD Algorithms
B. Briscoe
O. Albisser
08 August 2022
RFC Editor, please replace this URL with the permanent arXiv one
[SXEZ19]

Model-Agnostic and Efficient Exploration of Numerical Congestion Control State Space of Real-World TCP Implementations
Wei Sun
Lisong Xu
Sebastian Elbaum
Di Zhao
October 2021
IEEE/ACM Transactions on Networking vol. 29, no. 5, pp. 1990-2004
DOI 10.1109/tnet.2021.3078161
[XHR04]

Binary increase congestion control (BIC) for fast long-distance networks
Lisong Xu
K. Harfoush
Injong Rhee
February 2005
IEEE INFOCOM 2004
DOI 10.1109/infcom.2004.1354672
[HLRX07]

Impact of background traffic on performance of high-speed TCP variant protocols
Sangtae Ha
Long Le
Injong Rhee
Lisong Xu
May 2007
Computer Networks vol. 51, no. 7, pp. 1748-1762
DOI 10.1016/j.comnet.2006.11.005
[CEHRX09]

Stochastic convex ordering for multiplicative decrease internet congestion control
Han Cai
Do Young Eun
Sangtae Ha
Injong Rhee
Lisong Xu
February 2009
Computer Networks vol. 53, no. 3, pp. 365-381
DOI 10.1016/j.comnet.2008.10.012
[HR11]

Taming the elephants: New TCP slow start
Sangtae Ha
Injong Rhee
June 2011
Computer Networks vol. 55, no. 9, pp. 2092-2110
DOI 10.1016/j.comnet.2011.01.014
[BSCLU13]

Understanding TCP cubic performance in the cloud: A mean-field approach
Sonia Belhareth
Lucile Sassatelli
Denis Collange
Dino Lopez-Pacheco
Guillaume Urvoy-Keller
November 2013
2013 IEEE 2nd International Conference on Cloud Networking (CloudNet)
DOI 10.1109/cloudnet.2013.6710576
[LBEWK16]

A Comparison of TCP Congestion Control Algorithms in 10G Networks
Thomas Lukaseder
Leonard Bradatsch
Benjamin Erb
Rens W. Van Der Heijden
Frank Kargl
November 2016
2016 IEEE 41st Conference on Local Computer Networks (LCN)
DOI 10.1109/lcn.2016.121
[HRX08]

CUBIC: a new TCP-friendly high-speed TCP variant
Sangtae Ha
North Carolina State University, Raleigh, NC
Injong Rhee
North Carolina State University, Raleigh, NC
Lisong Xu
University of Nebraska, Lincoln, Nebraska
July 2008
ACM SIGOPS Operating Systems Review vol. 42, no. 5, pp. 64-74
DOI 10.1145/1400097.1400105
[K03]

Scalable TCP: improving performance in highspeed wide area networks
Tom Kelly
CERN-IT Division, Geneva, Switzerland
April 2003
ACM SIGCOMM Computer Communication Review vol. 33, no. 2, pp. 83-91
DOI 10.1145/956981.956989
[LIU16]

On Improving TCP Performance over Mobile Data Networks
Ke Liu
Jack Y.B. Lee
October 2016
IEEE Transactions on Mobile Computing vol. 15, no. 10, pp. 2522-2536
DOI 10.1109/tmc.2015.2500227
[RFC9000]

QUIC: A UDP-Based Multiplexed and Secure Transport
J. Iyengar, Ed.
M. Thomson, Ed.
May 2021
RFC 9000
DOI 10.17487/RFC9000
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC3649]

HighSpeed TCP for Large Congestion Windows
S. Floyd
December 2003
RFC 3649
DOI 10.17487/RFC3649
[RFC8312]

CUBIC for Fast Long-Distance Networks
I. Rhee
L. Xu
S. Ha
A. Zimmermann
L. Eggert
R. Scheffenegger
February 2018
RFC 8312
DOI 10.17487/RFC8312
[RFC3465]

TCP Congestion Control with Appropriate Byte Counting (ABC)
M. Allman
February 2003
RFC 3465
DOI 10.17487/RFC3465
[RFC6937]

Proportional Rate Reduction for TCP
M. Mathis
N. Dukkipati
Y. Cheng
May 2013
RFC 6937
DOI 10.17487/RFC6937
[RFC7661]

Updating TCP to Support Rate-Limited Traffic
G. Fairhurst
A. Sathiaseelan
R. Secchi
October 2015
RFC 7661
DOI 10.17487/RFC7661
[RFC3522]

The Eifel Detection Algorithm for TCP
R. Ludwig
M. Meyer
April 2003
RFC 3522
DOI 10.17487/RFC3522
[RFC3708]

Using TCP Duplicate Selective Acknowledgement (DSACKs) and Stream Control Transmission Protocol (SCTP) Duplicate Transmission Sequence Numbers (TSNs) to Detect Spurious Retransmissions
E. Blanton
M. Allman
February 2004
RFC 3708
DOI 10.17487/RFC3708
[RFC3742]

Limited Slow-Start for TCP with Large Congestion Windows
S. Floyd
March 2004
RFC 3742
DOI 10.17487/RFC3742
[RFC8511]

TCP Alternative Backoff with ECN (ABE)
N. Khademi
M. Welzl
G. Armitage
G. Fairhurst
December 2018
RFC 8511
DOI 10.17487/RFC8511
Acknowledgments
Richard Scheffenegger and Alexander Zimmermann originally co-authored [RFC8312].
These individuals suggested improvements to this document:
- Bob Briscoe
- Christian Huitema
- Gorry Fairhurst
- Jonathan Morton
- Juhamatti Kuusisaari
- Junho Choi
- Markku Kojo
- Martin Thomson
- Matt Mathis
- Matt Olson
- Michael Welzl
- Mirja Kühlewind
- Mohit P. Tahiliani
- Neal Cardwell
- Praveen Balasubramanian
- Randall Stewart
- Richard Scheffenegger
- Rod Grimes
- Tom Henderson
- Tom Petch
- Wesley Rosenblum
- Yoshifumi Nishida
- Yuchung Cheng
Evolution of CUBIC
Since draft-ietf-tcpm-rfc8312bis-09
- Improve text for Reno friendliness, multiplicative decrease and reference to HLRX07. (#152)
Since draft-ietf-tcpm-rfc8312bis-08
- Fix the text specifying when alpha_cubic SHOULD be set to 1 to indicate this should happen when cwnd >= prior_cwnd rather than cwnd >= W_max, since these are different in the fast convergence case (#146)
- Restrict use of cwnd directly on a congestion event (#148)
Since draft-ietf-tcpm-rfc8312bis-07
- Document the WG discussion and decision around [RFC5033] and [RFC2914] (#145)
Since draft-ietf-tcpm-rfc8312bis-06
- RFC7661 is safe even when cwnd grows beyond rwnd (#143)
Since draft-ietf-tcpm-rfc8312bis-05
- Clarify meaning of "application-limited" in Section 5.8 (#137)
- Create new subsections for spurious timeouts and spurious loss via ACK (#90)
- Brief discussion of convergence in Section 5.6 (#96)
- Add more test results to Section 5 and update some references (#91)
- Change wording around setting ssthresh (#131)
Since draft-ietf-tcpm-rfc8312bis-04
- Fix incorrect math (#106)
- Update RFC5681 (#99)
- Rephrase text around algorithmic alternatives, add HyStart++ (#85, #86, #90)
- Clarify what we mean by "new ACK" and use it in the text in more places. (#101)
- Rewrite the Responses to Sudden or Transient Events section (#98)
- Remove confusing text about cwnd_{start} in Section 4.2 (#100)
- Change terminology from "AIMD" to "Reno" (#108)
- Moved MUST NOT from app-limited section to main cubic AI section (#97)
- Clarify cwnd decrease during multiplicative decrease (#102)
- Clarify text around queuing and slow adaptation of CUBIC in wireless environments (#94)
- Set lower bound of cwnd to 1 MSS and use retransmit timer thereafter (#83)
- Use FlightSize instead of cwnd to update ssthresh (#114)
Since draft-ietf-tcpm-rfc8312bis-03
- Remove reference from abstract (#82)
Since draft-ietf-tcpm-rfc8312bis-02
- Description of packet loss rate p (#65)
- Clarification of TCP Friendly Equation for ABC and Delayed ACK (#66)
- add applicability to QUIC and SCTP (#61)
- clarity on setting alpha_{aimd} to 1 (#68)
- introduce alpha_{cubic} (#64)
- clarify cwnd growth in convex region (#69)
- add guidance for using bytes and mention that segments count is decimal (#67)
- add loss events detected by RACK and QUIC loss detection (#62)
Since draft-ietf-tcpm-rfc8312bis-01
- address Michael Scharf's editorial suggestions. (#59)
- add "Note to the RFC Editor" about removing underscores
Since draft-ietf-tcpm-rfc8312bis-00
- use updated xml2rfc with better text rendering of subscripts
Since draft-eggert-tcpm-rfc8312bis-03
- fix spelling nits
- rename to draft-ietf
- define W_{max} more clearly
Since draft-eggert-tcpm-rfc8312bis-02
- add definition for segments_acked and alpha_{aimd}. (#47)
- fix a mistake in W_{max} calculation in the fast convergence section. (#51)
- clarity on setting ssthresh and cwnd_{start} during multiplicative decrease. (#53)
Since draft-eggert-tcpm-rfc8312bis-01
- rename TCP-Friendly to AIMD-Friendly and rename Standard TCP to AIMD TCP to avoid confusion as CUBIC has been widely used on the Internet. (#38)
- change introductory text to reflect the significant broader deployment of CUBIC on the Internet. (#39)
- rephrase introduction to avoid referring to variables that have not been defined yet.
Since draft-eggert-tcpm-rfc8312bis-00
- acknowledge former co-authors (#15)
- prevent cwnd from becoming less than two (#7)
- add list of variables and constants (#5, #6)
- update K's definition and add bounds for CUBIC target cwnd [SXEZ19] (#1, #14)
- update W_{est} to use AIMD approach (#20)
- set alpha_{aimd} to 1 once W_{est} reaches W_{max} (#2)
- add Vidhi as co-author (#17)
- note for Fast Recovery during cwnd decrease due to congestion event (#11)
- add section for spurious congestion events (#23)
- initialize W_{est} after timeout and remove variable W_{last_max} (#28)
Since RFC8312
- converted to Markdown and xml2rfc v3
- updated references (as part of the conversion)
- updated author information
- various formatting changes
- move to Standards Track
Since the Original Paper
CUBIC has gone through a few changes since the initial release [HRX08] of its algorithm and implementation. This section highlights the differences between the original paper and [RFC8312].
- The original paper [HRX08] includes the pseudocode of CUBIC implementation using Linux's pluggable congestion control framework, which excludes system-specific optimizations. The simplified pseudocode might be a good source to start with and understand CUBIC.
- [HRX08] also includes experimental results showing its performance and fairness.
- The definition of beta_{cubic} constant was changed in [RFC8312]. For example, beta_{cubic} in the original paper was the window decrease constant while [RFC8312] changed it to CUBIC multiplication decrease factor. With this change, the current congestion window size after a congestion event in [RFC8312] was beta_{cubic} * W_{max} while it was (1-beta_{cubic}) * W_{max} in the original paper.
- Its pseudocode used W_{last_max} while [RFC8312] used W_{max}.
- Its AIMD-friendly window was W_{tcp} while [RFC8312] used W_{est}.